from visual import *

scene.center= (0,-2,0)
scene.autoscale= None

#Frames
fheart=frame()
fhead=frame(frame=fheart, pos=(0,1.75,0))
ftorso=frame(frame=fheart, pos=(0,.75,0))
fwaist=frame(frame=ftorso, pos=(0,-2.5,0))


fshoulderL=frame(frame=ftorso, pos=(-1,-.75,0))
felbowL=frame(frame=fshoulderL, pos=(-2,0,.75))
fwristL=frame(frame=felbowL, pos=(-1.75,0,.5))

fshoulderR=frame(frame=ftorso, pos=(1,-.75,0))
felbowR=frame(frame=fshoulderR, pos=(2,0,.75))
fwristR=frame(frame=felbowR, pos=(1.75,0,.5))

fhipL=frame(frame=fwaist, pos=(-.75,-1.5,0))
fkneeL=frame(frame=fhipL, pos=(0,-2.75,0))
fankleL=frame(frame=fkneeL, pos=(0,-2.75,0))

fhipR=frame(frame=fwaist, pos=(.75,-1.5,0))
fkneeR=frame(frame=fhipR, pos=(0,-2.75,0))
fankleR=frame(frame=fkneeR, pos=(0,-2.75,0))



#Body
head=sphere(frame=fhead, pos=(0,0,0), radius=1.25, color=color.blue)
chest=cylinder(frame=ftorso, pos=(0,0,0), axis=(0,-2.5,0), radius=0.25, color=color.blue)
collarboneL=cylinder(frame=ftorso, pos=(-1,-.75,0), axis=(2,0,0), radius=0.25, color=color.blue)
waist=cylinder(frame=fwaist, pos=(0,0,0), axis=(0,-1.5,0), radius=0.25, color=color.blue)
pelvis=cylinder(frame=fwaist, pos=(-.75,-1.5,0), axis=(1.5,0,0), radius=0.25, color=color.blue)

shoulderL=sphere(frame=fshoulderL, pos=(0,0,0), radius=.4, color=color.red)
elbowL=sphere(frame=felbowL, pos=(0,0,0), radius=.35, color=color.red)
wristL=sphere(frame=fwristL, pos=(0,0,0), radius=.35, color=color.red)
armUL=cylinder(frame=fshoulderL, pos=shoulderL.pos, axis=(felbowL.pos.x,felbowL.pos.y,felbowL.pos.z), radius=0.25, color=color.blue)
armLL=cylinder(frame=felbowL, pos=elbowL.pos, axis=(fwristL.pos.x,fwristL.pos.y,fwristL.pos.z), radius=0.25, color=color.blue)

shoulderR=sphere(frame=fshoulderR, pos=(0,0,0), radius=.4, color=color.red)
elbowR=sphere(frame=felbowR, pos=(0,0,0), radius=.35, color=color.red)
wristR=sphere(frame=fwristR, pos=(0,0,0), radius=.35, color=color.red)
armUR=cylinder(frame=fshoulderR, pos=shoulderR.pos, axis=(felbowR.pos.x,felbowR.pos.y,felbowR.pos.z), radius=0.25, color=color.blue)
armLR=cylinder(frame=felbowR, pos=elbowR.pos, axis=(fwristR.pos.x, fwristR.pos.y, fwristR.pos.z), radius=0.25, color=color.blue)

hipL=sphere(frame=fhipL, pos=(0,0,0), radius=.4, color=color.red)
kneeL=sphere(frame=fkneeL, pos=(0,0,0), radius=.35, color=color.red)
ankleL=sphere(frame=fankleL, pos=(0,0,0), radius=.35, color=color.red)
legUL=cylinder(frame=fhipL, pos=hipL.pos, axis=(fkneeL.pos.x,fkneeL.pos.y,fankleL.pos.z), radius=0.25, color=color.blue)
legLL=cylinder(frame=fkneeL, pos=kneeL.pos, axis=(fankleL.pos.x, fankleL.pos.y,fankleL.pos.z), radius=0.25, color=color.blue)

hipR=sphere(frame=fhipR, pos=(0,0,0), radius=.4, color=color.red)
kneeR=sphere(frame=fkneeR, pos=(0,0,0), radius=.35, color=color.red)
ankleR=sphere(frame=fankleR, pos=(0,0,0), radius=.35, color=color.red)
legUR=cylinder(frame=fhipR, pos=hipR.pos, axis=(fkneeR.pos.x,fkneeR.pos.y,fkneeR.pos.z), radius=0.25, color=color.blue)
legLR=cylinder(frame=fkneeR, pos=kneeR.pos, axis=(fankleR.pos.x,fankleR.pos.y,fankleR.pos.z), radius=0.25, color=color.blue)


#Showing frame orientation
def tripod(frm, clr, siz):
    right = cylinder(frame=frm, axis=siz*frm.axis, radius=0.1*siz, color=clr) #x axis
    tail = cone(frame=frm, axis =siz*frm.up, radius=0.5*siz, color=clr) #y axis

tripod(fhead, color.yellow, 1.5)
tripod(fshoulderL, color.yellow, .5)
tripod(felbowL, color.yellow, .5)
tripod(fwristL, color.yellow, .5)
tripod(fshoulderR, color.yellow, .5)
tripod(felbowR, color.yellow, .5)
tripod(fwristR, color.yellow, .5)
tripod(fhipL, color.yellow, .5)
tripod(fkneeL, color.yellow, .5)
tripod(fankleL, color.yellow, .5)
tripod(fhipR, color.yellow, .5)
tripod(fkneeR, color.yellow, .5)
tripod(fankleR, color.yellow, .5)

#Joint movement
def roll(frm,ang):
  frm.rotate(angle=ang, axis = cross(frm.up,frm.axis))

def pitch(frm,ang):
  frm.rotate(angle=ang, axis = frm.axis)

def yaw(frm,ang):
  frm.rotate(angle=ang, axis = frm.up)


for i in range (1,540,1):
    angle=math.radians(i)

#Shoulder Movement
    if i < 39:
        roll(fshoulderL, .1*angle)
        roll(fshoulderR, -.1*angle)
        roll(fhipL, .03*angle)
        roll(fhipR, -.03*angle)
    if 40 < i < 65:
        roll(fshoulderL, -.125*angle)
        roll(fshoulderR, .125*angle)
        roll(fhipL, -.015*angle)
        roll(fhipR, .015*angle)
    if 66 < i < 102:
        roll(fshoulderL, .05*angle)
        roll(fshoulderR, -.05*angle)
        roll(fhipL, .005*angle)
        roll(fhipR, -.005*angle)
    if 103 < i < 128:
        roll(fshoulderL, -.05*angle)
        roll(fshoulderR, .05*angle)
        roll(fhipL, -.005*angle)
        roll(fhipR, .005*angle)

#Elbow movement
    if 25 < i < 39:
        roll(felbowL, .1*angle)
        roll(felbowR, -.1*angle)
    if 40 < i < 51:
        roll(felbowL, -.1*angle)
        roll(felbowR, .1*angle)        
    if 92 < i < 102:
        roll(felbowL, .05*angle)
        roll(felbowR, -.05*angle)
    if 100 < i < 118:
        roll(felbowL, -.025*angle)
        roll(felbowR, .025*angle)

    rate(40)



#Picking controls
picked=None
dragging=false

while 1:
    if scene.mouse.events:
        m1 = scene.mouse.getevent() 
        if m1.click == 'left':
            if m1.pick != None:    
                picked=m1.pick.frame
            else:
                picked=None
             
        elif m1.press == 'left' and picked != None:
            origpos=scene.mouse.project(normal=(0,0,1))
        elif m1.drag== 'left' and picked != None:
            dragging=true
        elif m1.drop== 'left':
            dragging=false
    
    if dragging==true:
        currentpos=scene.mouse.project(normal=(0,0,1))
        if currentpos[1]-origpos[1]!=0:
            picked.rotate(angle=(currentpos[1]-origpos[1])/4,
                        axis=(0,0,1))
        if currentpos[0]-origpos[0]!=0:
            picked.rotate(angle=(currentpos[0]-origpos[0])/4,
                        axis=(0,1,0))
        origpos=currentpos


